using System;

namespace Mono.Debugger
{
	public interface ITargetStructObject : ITargetObject
	{
		ITargetStructType Type {
			get;
		}

		ITargetObject GetField (int index);

		ITargetObject GetProperty (int index);

		// <summary>
		//   Calls a function in the target to get a textual representation
		//   of the object.  For CIL applications, this'll call Object.ToString().
		// </summary>
		string PrintObject ();

		// <summary>
		//   Calls a method in the target.
		//
		//   Throws:
		//     LocationInvalidException   - the object could not be accessed
		//     TargetInvocationException  - the invocation raised an exception
		// </summary>
		ITargetObject InvokeMethod (int index, params ITargetObject[] args);
	}
}
